/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <gtk/gtk.h>

void on_about_ok_clicked (GtkButton *button, GtkWidget *dialog)
{
  gtk_widget_destroy(GTK_WIDGET(dialog));
  return;
}

void about_window (GtkWidget *widget, gpointer data)
{
  GtkWidget *about_dialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *label;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *ok_button;

  about_dialog = gtk_dialog_new ();
  gtk_container_border_width (GTK_CONTAINER (about_dialog), 10);
  gtk_window_set_title (GTK_WINDOW (about_dialog), "About");
  gtk_window_set_policy (GTK_WINDOW (about_dialog), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (about_dialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  label = gtk_label_new ("SU XViewer\n\nVersion 0.2.4\n\nby\nWatanabe Toshiki\nKyoto University\n\nwatanabe@tansa.kumst.kyoto-u.ac.jp");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label, TRUE, TRUE, 10);

  dialog_action_area1 = GTK_DIALOG (about_dialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  ok_button = gtk_button_new_with_label ("OK");
  gtk_object_set_data (GTK_OBJECT (about_dialog), "ok_button", ok_button);
  gtk_widget_show (ok_button);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), ok_button);
  gtk_signal_connect (GTK_OBJECT (ok_button), "clicked",
                      GTK_SIGNAL_FUNC (on_about_ok_clicked),
                      about_dialog);

  gtk_widget_show (about_dialog);
  
  gtk_grab_add(about_dialog);
  gtk_main ();
  gtk_grab_remove(about_dialog);

  return;
}
