/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * A very simple fileselecter by using an example of filesel.c 
*/

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include "suxviewer.h"

/* Get the selected filename */
void file_ok_sel (GtkWidget *widget, GtkFileSelection *fs)
{
  filename = (gchar *)strdup(gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));
  g_print ("Filename = %s\n", filename);

  gtk_widget_destroy (GTK_WIDGET(fs));
  return;
}

void file_selection (GtkWidget *widget, gpointer data)
{
    GtkWidget *filew;
    
    /* Create a new file selection widget */
    filew = gtk_file_selection_new ("File selection");
    gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION (filew));

    /* Connect the ok_button to file_ok_sel function */
    gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
			"clicked", (GtkSignalFunc) file_ok_sel, filew );
    
    /* Connect the cancel_button to destroy the widget */
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
			       "clicked", (GtkSignalFunc) gtk_widget_destroy,
			       GTK_OBJECT (filew));
    
    gtk_widget_show(filew);

    gtk_grab_add(filew);
    gtk_main ();
    gtk_grab_remove(filew);

    return;
}
