/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
#include "option.h"
#include "config.h"

/* Get options from radiobutton (fairly redundant...) */
void check_radio_button_style (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==0 ){
    option.style = strdup("normal");
  } else {
    option.style = strdup("seismic");
  }
#ifndef NODEBUG
  g_print ("style=%s \n", option.style);
#endif

  return;
}

void check_radio_button_wt (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==0 ){
    option.wt = strdup("0");
  } else {
    option.wt = strdup("1");
  }
#ifndef NODEBUG
  g_print ("wt=%s \n", option.wt);
#endif

  return;
}

void check_radio_button_va (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==0 ){
    option.va = strdup("0");
  } else {
    option.va = strdup("1");
  }
#ifndef NODEBUG
  g_print ("va=%s \n", option.va);
#endif

  return;
}

void check_radio_button_int (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==1 ){
    option.interp = strdup("1");
  } else {
    option.interp = strdup("0");
  }
#ifndef NODEBUG
  g_print ("interp=%s \n", option.interp);
#endif

  return;
}

void check_radio_button_grid1 (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==0 ){
    option.grid1 = strdup("solid");
  } else if ( i==1 ) {
    option.grid1 = strdup("dash");
  } else if ( i==2 ){
    option.grid1 = strdup("dot");
  } else {
    option.grid1 = strdup("none");
  }
#ifndef NODEBUG
  g_print ("grid1=%s \n", option.grid1);
#endif

  return;
}

void check_radio_button_grid2 (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==0 ){
    option.grid2 = strdup("solid");
  } else if ( i==1 ) {
    option.grid2 = strdup("dash");
  } else if ( i==2 ){
    option.grid2 = strdup("dot");
  } else {
    option.grid2 = strdup("none");
  }
#ifndef NODEBUG
  g_print ("grid2=%s \n", option.grid2);
#endif

  return;
}

/* Text entry, spinbutton etc, */
void on_option_ok_clicked (GtkButton *button, GtkWidget *dialog)
{
  GtkWidget *key;
  GtkWidget *bias;
  GtkWidget *perc;
  GtkWidget *clip;
  GtkWidget *xcur;
  GtkWidget *wigclip;
  GtkWidget *mpicks;

  GtkWidget *title;
  GtkWidget *label1;
  GtkWidget *min1;
  GtkWidget *max1;
  GtkWidget *d1num;
  GtkWidget *tic1;
  GtkWidget *label2;
  GtkWidget *min2;
  GtkWidget *max2;
  GtkWidget *d2num;
  GtkWidget *tic2;

  GtkWidget *add;

  option.yes = 1;

  key = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					  "combo_key");
  option.key = strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(key)->entry)));
  bias = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_bias");
  option.bias = strdup(gtk_entry_get_text(GTK_ENTRY(bias)));
  perc = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_perc");
  option.perc = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(perc)->entry)));
  clip = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_clip");
  option.clip = strdup(gtk_entry_get_text(GTK_ENTRY(clip)));
  xcur = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_xcur");
  option.xcur = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(xcur)->entry)));
  wigclip = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					      "spinbutton_wigclip");
  option.wigclip = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(wigclip)->entry)));
  mpicks = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					     "entry_mpicks");
  option.mpicks = strdup(gtk_entry_get_text(GTK_ENTRY(mpicks)));
  

  title = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					    "entry_title");
  option.title = strdup(gtk_entry_get_text(GTK_ENTRY(title)));
  label1 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					     "entry_label1");
  option.label1 = strdup(gtk_entry_get_text(GTK_ENTRY(label1)));
  min1 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_min1");
  option.min1 = strdup(gtk_entry_get_text(GTK_ENTRY(min1)));
  max1 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_max1");
  option.max1 = strdup(gtk_entry_get_text(GTK_ENTRY(max1)));
  d1num = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					    "entry_d1num");
  option.d1num = strdup(gtk_entry_get_text(GTK_ENTRY(d1num)));
  tic1 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_tic1");
  option.tic1 = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(tic1)->entry)));
  label2 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					     "entry_label2");
  option.label2 = strdup(gtk_entry_get_text(GTK_ENTRY(label2)));
  min2 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_min2");
  option.min2 = strdup(gtk_entry_get_text(GTK_ENTRY(min2)));
  max2 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "entry_max2");
  option.max2 = strdup(gtk_entry_get_text(GTK_ENTRY(max2)));
  d2num = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					    "entry_d2num");
  option.d2num = strdup(gtk_entry_get_text(GTK_ENTRY(d2num)));
  tic2 = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_tic2");
  option.tic2 = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(tic2)->entry)));
  
  add = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					  "entry_add");
  option.add = strdup(gtk_entry_get_text(GTK_ENTRY(add)));

#ifndef NODEBUG
  g_print ("key=%s \n", option.key);
  g_print ("bias=%s \n", option.bias);
  g_print ("perc=%s \n", option.perc);
  g_print ("clip=%s \n", option.clip);
  g_print ("xcur=%s \n", option.xcur);
  g_print ("wigclip=%s \n", option.wigclip);
  g_print ("mpicks=\"%s\" \n", option.mpicks);
  g_print ("title=\"%s\" \n", option.title);
  g_print ("label1=\"%s\" \n", option.label1);
  g_print ("x1beg=%s \n", option.min1);
  g_print ("x1end=%s \n", option.max1);
  g_print ("d1num=%s \n", option.d1num);
  g_print ("n1tic=%s \n", option.tic1);
  g_print ("label2=\"%s\" \n", option.label2);
  g_print ("x2beg=%s \n", option.min2);
  g_print ("x2end=%s \n", option.max2);
  g_print ("d2num=%s \n", option.d2num);
  g_print ("n2tic=%s \n", option.tic2);
  g_print ("%s \n", option.add);
#endif

  gtk_widget_destroy(GTK_WIDGET(dialog)); 

  return;
}

void on_option_cancel_clicked (GtkButton *button, GtkWidget *dialog) 
{
  gtk_widget_destroy(GTK_WIDGET(dialog));
}

/* Not available yet. */
void on_option_reset_clicked (GtkButton *button, GtkWidget *dialog)
{
  gtk_widget_destroy(GTK_WIDGET(dialog));
}

