/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <string.h>
#include <gtk/gtk.h>
#include "option.h"
#include "config.h"

/* Widget as global variable */
  GtkWidget *table2;

/* Activate legend options */
void on_radiobutton_ly_toggled (GtkToggleButton *togglebutton, gpointer data)
{
  gtk_widget_set_sensitive (table2, TRUE);
}

/* Deactivate legend options */
void on_radiobutton_ln_toggled (GtkToggleButton *togglebutton, gpointer data)
{
  gtk_widget_set_sensitive (table2, FALSE);
}

void check_radiobutton_legend (GtkWidget *widget, gpointer data)
{
  int i;

  GtkWidget *radio_button;
  GSList *node;
  GSList *list = (GSList *)data;

  for(i = 0; (node = g_slist_nth(list, i)) != NULL; i++) {
    radio_button = (GtkWidget *)node->data;
    if (GTK_TOGGLE_BUTTON(radio_button)->active) {
      break;
    } 
  }
  if ( i==1 ){
    legend.yes = 1;
    legend.legend = strdup("1");
  } else {
    legend.yes = 0;
    legend.legend = strdup("0");
  }
#ifndef NODEBUG
  g_print ("legend=%s \n", legend.legend);
#endif

  return;
}

void get_legend_options (GtkButton *button, GtkWidget *dialog)
{
  GtkWidget *units;
  GtkWidget *xbox;
  GtkWidget *ybox;
  GtkWidget *lwidth;
  GtkWidget *lheight;
  GtkWidget *lx;
  GtkWidget *ly;

  if (legend.yes != 1) return;

  units = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					    "entry_units");
  legend.units = strdup(gtk_entry_get_text(GTK_ENTRY(units)));
  xbox = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_xb");
  legend.xbox = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(xbox)->entry)));
  ybox = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					   "spinbutton_yb");
  legend.ybox = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(ybox)->entry)));
  lwidth = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "spinbutton_lw");
  legend.lwidth = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(lwidth)->entry)));
  lheight = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					      "spinbutton_lh");
  legend.lheight = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(lheight)->entry)));
  lx = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					 "spinbutton_lx");
  legend.lx = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(lx)->entry)));
  ly = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
					 "spinbutton_ly");
  legend.ly = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(ly)->entry)));

#ifndef NODEBUG
  g_print ("units=%s \n", legend.units);
  g_print ("xbox=%s \n", legend.xbox);
  g_print ("ybox=%s \n", legend.ybox);
  g_print ("lwidth=%s \n", legend.lwidth);
  g_print ("lheight=%s \n", legend.lheight);
  g_print ("lx=%s \n", legend.lx);
  g_print ("ly=%s \n", legend.ly);
#endif

  return;
}

void on_image_ok_clicked (GtkButton *button, GtkWidget *dialog)
{
  GtkWidget *bperc;
  GtkWidget *wperc;
  GtkWidget *bclip;
  GtkWidget *wclip;
  GtkWidget *blank;
  GtkWidget *cmap;

  image.yes = 1;
  bperc = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "entry_bp");
  image.bperc = strdup(gtk_entry_get_text(GTK_ENTRY(bperc)));
  wperc = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "entry_wp");
  image.wperc = strdup(gtk_entry_get_text(GTK_ENTRY(wperc)));
  bclip = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "entry_bc");
  image.bclip = strdup(gtk_entry_get_text(GTK_ENTRY(bclip)));
  wclip = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "entry_wc");
  image.wclip = strdup(gtk_entry_get_text(GTK_ENTRY(wclip)));
  blank = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "spinbutton_blank");
  image.blank = strdup(gtk_entry_get_text(&(GTK_SPIN_BUTTON(blank)->entry)));
  cmap = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (dialog),
                                             "combo_cmap");
  image.cmap = strdup(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(cmap)->entry)));

#ifndef NODEBUG
  g_print ("bperc=%s \n", image.bperc);
  g_print ("wperc=%s \n", image.wperc);
  g_print ("bclip=%s \n", image.bclip);
  g_print ("wclip=%s \n", image.wclip);
  g_print ("blank=%s \n", image.blank);
  g_print ("cmap=%s \n", image.cmap);
#endif

  gtk_widget_destroy(GTK_WIDGET(dialog)); 
  return;
}

void on_image_cancel_clicked (GtkButton *button, GtkWidget *dialog)
{
  gtk_widget_destroy(GTK_WIDGET(dialog));
  return;
}

void create_dialog_imageopt (GtkWidget *widget, gpointer data)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *frame1;
  GtkWidget *table1;
  GtkWidget *label_wp;
  GtkWidget *label_bc;
  GtkWidget *label_wc;
  GtkWidget *label_blank;
  GtkWidget *entry_bp;
  GtkWidget *entry_wp;
  GtkWidget *entry_bc;
  GtkWidget *entry_wc;
  GtkObject *spinbutton_blank_adj;
  GtkWidget *spinbutton_blank;
  GtkWidget *label_bp;
  GtkWidget *frame2;
  GtkWidget *hbox1;
  GtkWidget *label_cmap;
  GtkWidget *combo_cmap;
  GList *combo_cmap_items = NULL;
  GtkWidget *frame3;
  GtkWidget *vbox2;
  GtkWidget *hbox2;
  GtkWidget *label_legend;
  GtkWidget *hbox3;
  GSList *legend_group = NULL;
  GtkWidget *radiobutton_ly;
  GtkWidget *radiobutton_ln;
  GtkWidget *label_units;
  GtkWidget *label_xb;
  GtkWidget *label_yb;
  GtkWidget *label_lw;
  GtkWidget *label_lh;
  GtkWidget *label_lx;
  GtkWidget *label_ly;
  GtkWidget *entry_units;
  GtkWidget *spinbutton_xb;
  GtkWidget *spinbutton_yb;
  GtkWidget *spinbutton_lw;
  GtkWidget *spinbutton_lh;
  GtkWidget *spinbutton_lx;
  GtkWidget *spinbutton_ly;
  GtkObject *spinbutton_xb_adj;
  GtkObject *spinbutton_yb_adj;
  GtkObject *spinbutton_lw_adj;
  GtkObject *spinbutton_lh_adj;
  GtkObject *spinbutton_lx_adj;
  GtkObject *spinbutton_ly_adj;

  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;

  /* Initialize */
  init_image(); 
  init_legend(); 
  
  /* Create Dialog */
  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "dialog1");
  gtk_window_set_title (GTK_WINDOW (dialog1), "Image Option");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);

  /* Image params */
  frame1 = gtk_frame_new ("Image Parameters");
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame1), 5);

  table1 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (frame1), table1);
  gtk_container_border_width (GTK_CONTAINER (table1), 5);

  label_bp = gtk_label_new ("Bperc: ");
  gtk_widget_show (label_bp);
  gtk_table_attach (GTK_TABLE (table1), label_bp, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_bp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_bp), 0.2, 0.5);

  label_wp = gtk_label_new ("Wperc: ");
  gtk_widget_show (label_wp);
  gtk_table_attach (GTK_TABLE (table1), label_wp, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_wp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_wp), 0.2, 0.5);

  label_bc = gtk_label_new ("Bclip: ");
  gtk_widget_show (label_bc);
  gtk_table_attach (GTK_TABLE (table1), label_bc, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_bc), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_bc), 0.2, 0.5);

  label_wc = gtk_label_new ("Wclip: ");
  gtk_widget_show (label_wc);
  gtk_table_attach (GTK_TABLE (table1), label_wc, 0, 1, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_wc), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_wc), 0.2, 0.5);

  label_blank = gtk_label_new ("Blank: ");
  gtk_widget_show (label_blank);
  gtk_table_attach (GTK_TABLE (table1), label_blank, 0, 1, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_blank), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_blank), 0.2, 0.5);

  entry_bp = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "entry_bp", entry_bp);
  gtk_widget_show (entry_bp);
  gtk_table_attach (GTK_TABLE (table1), entry_bp, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_bp), "(perc)");

  entry_wp = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "entry_wp", entry_wp);
  gtk_widget_show (entry_wp);
  gtk_table_attach (GTK_TABLE (table1), entry_wp, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_wp), "(100-perc)");

  entry_bc = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "entry_bc", entry_bc);
  gtk_widget_show (entry_bc);
  gtk_table_attach (GTK_TABLE (table1), entry_bc, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_bc), "(clip)");

  entry_wc = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "entry_wc", entry_wc);
  gtk_widget_show (entry_wc);
  gtk_table_attach (GTK_TABLE (table1), entry_wc, 1, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_wc), "(-clip)");

  spinbutton_blank_adj = gtk_adjustment_new (0, 0, 1, 0.1, 10, 10);
  spinbutton_blank = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_blank_adj), 1, 1);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_blank", spinbutton_blank);
  gtk_widget_show (spinbutton_blank);
  gtk_table_attach (GTK_TABLE (table1), spinbutton_blank, 1, 2, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  /* Color */
  frame2 = gtk_frame_new ("Color");
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame2), 5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (frame2), hbox1);
  gtk_container_border_width (GTK_CONTAINER (hbox1), 5);

  label_cmap = gtk_label_new ("Cmap: ");
  gtk_widget_show (label_cmap);
  gtk_box_pack_start (GTK_BOX (hbox1), label_cmap, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label_cmap), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_cmap), 0.2, 0.5);

  combo_cmap = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "combo_cmap", combo_cmap);
  gtk_widget_show (combo_cmap);
  gtk_box_pack_start (GTK_BOX (hbox1), combo_cmap, TRUE, TRUE, 0);
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv0");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv1");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv2");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv3");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv4");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv5");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv6");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv7");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv8");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv9");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv10");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv11");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv12");
  combo_cmap_items = g_list_append (combo_cmap_items, "hsv13");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb0");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb1");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb2");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb3");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb4");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb5");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb6");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb7");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb8");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb9");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb10");
  combo_cmap_items = g_list_append (combo_cmap_items, "rgb11");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_cmap), combo_cmap_items);
  g_list_free (combo_cmap_items);

  /* Legend */
  frame3 = gtk_frame_new ("Legend");
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox1), frame3, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame3), 5);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame3), vbox2);
  gtk_container_border_width (GTK_CONTAINER (vbox2), 5);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox2, TRUE, TRUE, 0);

  label_legend = gtk_label_new ("Legend: ");
  gtk_widget_show (label_legend);
  gtk_box_pack_start (GTK_BOX (hbox2), label_legend, TRUE, TRUE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox3, TRUE, TRUE, 0);

  radiobutton_ly = gtk_radio_button_new_with_label (legend_group, "Yes");
  legend_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_ly));
  gtk_widget_show (radiobutton_ly);
  gtk_box_pack_start (GTK_BOX (hbox3), radiobutton_ly, TRUE, TRUE, 0);

  radiobutton_ln = gtk_radio_button_new_with_label (legend_group, "No");
  legend_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_ln));
  gtk_widget_show (radiobutton_ln);
  gtk_box_pack_start (GTK_BOX (hbox3), radiobutton_ln, TRUE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_ln), TRUE);

  table2 = gtk_table_new (7, 2, FALSE);
  gtk_widget_show (table2);
  gtk_box_pack_start (GTK_BOX (vbox2), table2, TRUE, TRUE, 0);
  gtk_widget_set_sensitive (table2, FALSE);

  label_units = gtk_label_new ("Units Label: ");
  gtk_widget_show (label_units);
  gtk_table_attach (GTK_TABLE (table2), label_units, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_units), GTK_JUSTIFY_LEFT);

  label_xb = gtk_label_new ("Xbox: ");
  gtk_widget_show (label_xb);
  gtk_table_attach (GTK_TABLE (table2), label_xb, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_xb), GTK_JUSTIFY_LEFT);

  label_yb = gtk_label_new ("Ybox: ");
  gtk_widget_show (label_yb);
  gtk_table_attach (GTK_TABLE (table2), label_yb, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_yb), GTK_JUSTIFY_LEFT);

  label_lw = gtk_label_new ("width: ");
  gtk_widget_show (label_lw);
  gtk_table_attach (GTK_TABLE (table2), label_lw, 0, 1, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_lw), GTK_JUSTIFY_LEFT);

  label_lh = gtk_label_new ("Height: ");
  gtk_widget_show (label_lh);
  gtk_table_attach (GTK_TABLE (table2), label_lh, 0, 1, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_lh), GTK_JUSTIFY_LEFT);

  label_lx = gtk_label_new ("X-position: ");
  gtk_widget_show (label_lx);
  gtk_table_attach (GTK_TABLE (table2), label_lx, 0, 1, 5, 6,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_lx), GTK_JUSTIFY_LEFT);

  label_ly = gtk_label_new ("Y-position: ");
  gtk_widget_show (label_ly);
  gtk_table_attach (GTK_TABLE (table2), label_ly, 0, 1, 6, 7,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_ly), GTK_JUSTIFY_LEFT);

  entry_units = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "entry_units", entry_units);
  gtk_widget_show (entry_units);
  gtk_table_attach (GTK_TABLE (table2), entry_units, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_units), "(none)");

  spinbutton_xb_adj = gtk_adjustment_new (50, 0, 100, 1, 10, 10);
  spinbutton_xb = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_xb_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_xb", spinbutton_xb);
  gtk_widget_show (spinbutton_xb);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_xb, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_yb_adj = gtk_adjustment_new (50, 0, 100, 1, 10, 10);
  spinbutton_yb = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_yb_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_yb", spinbutton_yb);
  gtk_widget_show (spinbutton_yb);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_yb, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_lw_adj = gtk_adjustment_new (16, 1, 32, 1, 10, 10);
  spinbutton_lw = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_lw_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_lw", spinbutton_lw);
  gtk_widget_show (spinbutton_lw);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_lw, 1, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_lh_adj = gtk_adjustment_new (230, 1, 500, 5, 10, 10);
  spinbutton_lh = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_lh_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_lh", spinbutton_lh);
  gtk_widget_show (spinbutton_lh);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_lh, 1, 2, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_lx_adj = gtk_adjustment_new (3, 0, 50, 1, 10, 10);
  spinbutton_lx = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_lx_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_lx", spinbutton_lx);
  gtk_widget_show (spinbutton_lx);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_lx, 1, 2, 5, 6,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_ly_adj = gtk_adjustment_new (155, 1, 500, 5, 10, 10);
  spinbutton_ly = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_ly_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "spinbutton_ly", spinbutton_ly);
  gtk_widget_show (spinbutton_ly);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_ly, 1, 2, 6, 7,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  gtk_signal_connect (GTK_OBJECT (radiobutton_ly), "toggled", 
                       GTK_SIGNAL_FUNC (on_radiobutton_ly_toggled), 
                       NULL); 

  gtk_signal_connect (GTK_OBJECT (radiobutton_ln), "toggled", 
                       GTK_SIGNAL_FUNC (on_radiobutton_ln_toggled), 
                       NULL); 

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label ("OK");
  gtk_widget_show (button_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_ok);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radiobutton_legend),
                      (gpointer)legend_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (get_legend_options),
                      GTK_WIDGET (dialog1));
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_image_ok_clicked),
                      GTK_WIDGET (dialog1));

  button_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_show (button_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_cancel);
  gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_image_cancel_clicked),
                      GTK_WIDGET (dialog1));

  gtk_widget_show (dialog1);

  gtk_grab_add(dialog1);
  gtk_main ();
  gtk_grab_remove(dialog1);

  return;
}
