/*  suxviewer
 *  by Watanabe Toshiki, Kyoto University
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <gtk/gtk.h>
#include <string.h>
#include "option.h"

void init_option (void)
{
  option.yes = 0;
  option.style = strdup("seismic");
  option.wt = strdup("1");
  option.va = strdup("1");
  option.interp = strdup("0");
  option.key = strdup("tracl");
  option.bias = strdup("0.0");
  option.perc = strdup("100");
  option.clip = strdup("(perc)");
  option.xcur = strdup("1");
  option.wigclip = strdup("0");
  option.title = strdup("");
  option.label1 = strdup("Time (s)");
  option.min1 = strdup("(min)"); 
  option.max1 = strdup("(max)"); 
  option.d1num = strdup("(auto)"); 
  option.tic1 = strdup("1");
  option.grid1 = strdup("none");
  option.label2 = strdup("Trace Number");
  option.min2 = strdup("(min)"); 
  option.max2 = strdup("(max)"); 
  option.d2num = strdup("(auto)"); 
  option.tic2 = strdup("1");
  option.grid2 = strdup("none");
  option.mpicks = strdup("/dev/tty");

  image.yes = 0;
  legend.yes = 0;
  curve.ncurve = 0;

  return;
}

void init_image (void)
{
  image.bperc = strdup("(perc)");
  image.wperc = strdup("(100-perc)");
  image.bclip = strdup("(clip)");
  image.wclip = strdup("(-clip)");
  image.blank = strdup("0");
  image.cmap  = strdup("hsv0");

  return;
}

void init_legend (void)
{
  legend.legend = strdup("0");
  legend.units = strdup("(none)");
  legend.xbox = strdup("50");
  legend.ybox = strdup("50");
  legend.lwidth = strdup("16");
  legend.lheight = strdup("230");
  legend.lx = strdup("3");
  legend.ly = strdup("155");

  return;
}

void init_curve (void)
{
  curve.curve[0] = '\0'; 
  curve.npair[0] = '\0';
  curve.curvecolor[0] = '\0';

  return;
}

