/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <gtk/gtk.h>
#include <string.h>
#include "option.h"

void create_dialog_option (GtkWidget *widget, gpointer data)
{
  GtkWidget *dialog_option;

  GtkWidget *dialog_vbox1;
  GtkWidget *vbox_u;
  GtkWidget *vbox_l;
  GtkWidget *hbox_l;
  GtkWidget *hbox_r;
  GtkWidget *vbox1;
  GtkWidget *vbox2;

  GtkWidget *frame_style;
  GtkWidget *table4;
  GtkWidget *label_style;
  GtkWidget *label_wt;
  GtkWidget *label_va;
  GtkWidget *label_interp;
  GtkWidget *label_key;
  GtkWidget *hbox12;
  GSList *style_group = NULL;
  GtkWidget *radiobutton_seis;
  GtkWidget *radiobutton_norm;
  GtkWidget *hbox11;
  GSList *wt_group = NULL;
  GtkWidget *radiobutton_wt_yes;
  GtkWidget *radiobutton_wt_no;
  GtkWidget *hbox10;
  GSList *va_group = NULL;
  GtkWidget *radiobutton_va_yes;
  GtkWidget *radiobutton_va_no;
  GtkWidget *hbox9;
  GSList *int_group = NULL;
  GtkWidget *radiobutton_int_yes;
  GtkWidget *radiobutton_int_no;
  GtkWidget *combo_key;
  GList *combo_key_items = NULL;

  GtkWidget *frame_param;
  GtkWidget *table3;
  GtkWidget *label_bias;
  GtkWidget *label_perc;
  GtkWidget *label_clip; 
  GtkWidget *label_xcur;
  GtkWidget *label_wigclip;
  GtkWidget *entry_bias;
  GtkObject *spinbutton_perc_adj;
  GtkWidget *spinbutton_perc;
  GtkWidget *entry_clip;
  GtkObject *spinbutton_xcur_adj;
  GtkWidget *spinbutton_xcur;
  GtkObject *spinbutton_wigclip_adj;
  GtkWidget *spinbutton_wigclip;

  GtkWidget *frame_mpick;
  GtkWidget *hbox6;
  GtkWidget *label_mpicks;
  GtkWidget *entry_mpicks;

  GtkWidget *frame_title;
  GtkWidget *hbox5;
  GtkWidget *label_title;
  GtkWidget *entry_title;

  GtkWidget *frame_axis;
  GtkWidget *table2;
  GtkWidget *label_axis1;
  GtkWidget *label_label1;
  GtkWidget *label_min1;
  GtkWidget *label_max1;
  GtkWidget *label_d1num;
  GtkWidget *label_tic1;
  GtkWidget *label_grid1;
  GtkWidget *entry_min1;
  GtkWidget *entry_max1;
  GtkWidget *entry_d1num;
  GtkObject *spinbutton_tic1_adj;
  GtkWidget *spinbutton_tic1;
  GtkWidget *hbox7;
  GSList *grid1_group = NULL;
  GtkWidget *radiobutton_grid1_none;
  GtkWidget *radiobutton_grid1_dot;
  GtkWidget *radiobutton_grid1_dash;
  GtkWidget *radiobutton_grid1_solid;

  GtkWidget *label_axis2;
  GtkWidget *label_label2;
  GtkWidget *label_min2;
  GtkWidget *label_max2;
  GtkWidget *label_d2num;
  GtkWidget *label_tic2;
  GtkWidget *label_grid2;
  GtkWidget *entry_label1;
  GtkWidget *entry_label2;
  GtkWidget *entry_min2;
  GtkWidget *entry_max2;
  GtkWidget *entry_d2num;
  GtkObject *spinbutton_tic2_adj;
  GtkWidget *spinbutton_tic2;
  GtkWidget *hbox8;
  GSList *grid2_group = NULL;
  GtkWidget *radiobutton_grid2_none;
  GtkWidget *radiobutton_grid2_dot;
  GtkWidget *radiobutton_grid2_dash;
  GtkWidget *radiobutton_grid2_solid;

  GtkWidget *frame_more;
  GtkWidget *vbox_m1;
  GtkWidget *hbox_m1;
  GtkWidget *button_ximage;
  GtkWidget *button_curve;
  GtkWidget *hbox_m2;
  GtkWidget *label_add;
  GtkWidget *entry_add;

  GtkWidget *dialog_action_area1;
  GtkWidget *hbuttonbox1;
  GtkWidget *button_ok;
  GtkWidget *button_reset;
  GtkWidget *button_cancel;

  /* Initialize */
  init_option(); 

  /* Create Dialog */
  dialog_option = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog_option), "Option");
  gtk_window_set_policy (GTK_WINDOW (dialog_option), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog_option)->vbox;
  gtk_widget_show (dialog_vbox1);

  vbox_u = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_u);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox_u, TRUE, TRUE, 0);

  /* Left Panel */
  hbox_l = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_l);
  gtk_box_pack_start (GTK_BOX (vbox_u), hbox_l, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox_l), vbox1, TRUE, TRUE, 0);

  /* Plot style */
  frame_style = gtk_frame_new ("Plot Style");
  gtk_widget_show (frame_style);
  gtk_box_pack_start (GTK_BOX (vbox1), frame_style, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_style), 5);

  table4 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (table4);
  gtk_container_add (GTK_CONTAINER (frame_style), table4);
  gtk_container_border_width (GTK_CONTAINER (table4), 5);

  label_style = gtk_label_new ("Style: ");
  gtk_widget_show (label_style);
  gtk_table_attach (GTK_TABLE (table4), label_style, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_style), GTK_JUSTIFY_LEFT);

  label_wt = gtk_label_new ("Wiggle Trace: ");
  gtk_widget_show (label_wt);
  gtk_table_attach (GTK_TABLE (table4), label_wt, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_wt), GTK_JUSTIFY_LEFT);

  label_va = gtk_label_new ("Variable Area:");
  gtk_widget_show (label_va);
  gtk_table_attach (GTK_TABLE (table4), label_va, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_va), GTK_JUSTIFY_LEFT);

  label_interp = gtk_label_new ("Interpolation:");
  gtk_widget_show (label_interp);
  gtk_table_attach (GTK_TABLE (table4), label_interp, 0, 1, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_interp), GTK_JUSTIFY_LEFT);

  label_key = gtk_label_new ("Keyword: ");
  gtk_widget_show (label_key);
  gtk_table_attach (GTK_TABLE (table4), label_key, 0, 1, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_key), GTK_JUSTIFY_LEFT);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_table_attach (GTK_TABLE (table4), hbox12, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_seis = gtk_radio_button_new_with_label (style_group, "Seismic");
  style_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_seis));
  gtk_widget_show (radiobutton_seis);
  gtk_box_pack_start (GTK_BOX (hbox12), radiobutton_seis, TRUE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_seis), TRUE);

  radiobutton_norm = gtk_radio_button_new_with_label (style_group, "Normal");
  style_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_norm));
  gtk_widget_show (radiobutton_norm);
  gtk_box_pack_start (GTK_BOX (hbox12), radiobutton_norm, TRUE, TRUE, 0);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox11);
  gtk_table_attach (GTK_TABLE (table4), hbox11, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_wt_yes = gtk_radio_button_new_with_label (wt_group, "Yes");
  wt_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_wt_yes));
  gtk_widget_show (radiobutton_wt_yes);
  gtk_box_pack_start (GTK_BOX (hbox11), radiobutton_wt_yes, TRUE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_wt_yes), TRUE);

  radiobutton_wt_no = gtk_radio_button_new_with_label (wt_group, "No");
  wt_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_wt_no));
  gtk_widget_show (radiobutton_wt_no);
  gtk_box_pack_start (GTK_BOX (hbox11), radiobutton_wt_no, TRUE, TRUE, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox10);
  gtk_table_attach (GTK_TABLE (table4), hbox10, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_va_yes = gtk_radio_button_new_with_label (va_group, "Yes");
  va_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_va_yes));
  gtk_widget_show (radiobutton_va_yes);
  gtk_box_pack_start (GTK_BOX (hbox10), radiobutton_va_yes, TRUE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_va_yes), TRUE);

  radiobutton_va_no = gtk_radio_button_new_with_label (va_group, "No");
  va_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_va_no));
  gtk_widget_show (radiobutton_va_no);
  gtk_box_pack_start (GTK_BOX (hbox10), radiobutton_va_no, TRUE, TRUE, 0);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox9);
  gtk_table_attach (GTK_TABLE (table4), hbox9, 1, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_int_yes = gtk_radio_button_new_with_label (int_group, "Yes");
  int_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_int_yes));
  gtk_widget_show (radiobutton_int_yes);
  gtk_box_pack_start (GTK_BOX (hbox9), radiobutton_int_yes, TRUE, TRUE, 0);

  radiobutton_int_no = gtk_radio_button_new_with_label (int_group, "No");
  int_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_int_no));
  gtk_widget_show (radiobutton_int_no);
  gtk_box_pack_start (GTK_BOX (hbox9), radiobutton_int_no, TRUE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_int_no), TRUE);

  combo_key = gtk_combo_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "combo_key", combo_key);
  gtk_widget_show (combo_key);
  gtk_table_attach (GTK_TABLE (table4), combo_key, 1, 2, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  combo_key_items = g_list_append (combo_key_items, "tracl");
  combo_key_items = g_list_append (combo_key_items, "offset");
  combo_key_items = g_list_append (combo_key_items, "cdp");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_key), combo_key_items);
  g_list_free (combo_key_items);

  /* Plot parameters */
  frame_param = gtk_frame_new ("Plot Parameters");
  gtk_widget_show (frame_param);
  gtk_box_pack_start (GTK_BOX (vbox1), frame_param, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_param), 5);

  table3 = gtk_table_new (5, 2, FALSE);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (frame_param), table3);
  gtk_container_border_width (GTK_CONTAINER (table3), 5);

  label_bias = gtk_label_new ("Bias: ");
  gtk_widget_show (label_bias);
  gtk_table_attach (GTK_TABLE (table3), label_bias, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_bias), GTK_JUSTIFY_LEFT);

  label_perc = gtk_label_new ("Perc: ");
  gtk_widget_show (label_perc);
  gtk_table_attach (GTK_TABLE (table3), label_perc, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_perc), GTK_JUSTIFY_LEFT);

  label_clip = gtk_label_new ("Clip: ");
  gtk_widget_show (label_clip);
  gtk_table_attach (GTK_TABLE (table3), label_clip, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_clip), GTK_JUSTIFY_LEFT);

  label_xcur = gtk_label_new ("Xcur: ");
  gtk_widget_show (label_xcur);
  gtk_table_attach (GTK_TABLE (table3), label_xcur, 0, 1, 3, 4,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_xcur), GTK_JUSTIFY_LEFT);

  label_wigclip = gtk_label_new ("Wigclip: ");
  gtk_widget_show (label_wigclip);
  gtk_table_attach (GTK_TABLE (table3), label_wigclip, 0, 1, 4, 5,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_wigclip), GTK_JUSTIFY_LEFT);

  entry_bias = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_bias", entry_bias);
  gtk_widget_show (entry_bias);
  gtk_table_attach (GTK_TABLE (table3), entry_bias, 1, 2, 0, 1,
		    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0); 
  gtk_entry_set_text (GTK_ENTRY (entry_bias), "0.0");

  spinbutton_perc_adj = gtk_adjustment_new (100, 0, 100, 1, 10, 10);
  spinbutton_perc = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_perc_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog_option), "spinbutton_perc", spinbutton_perc);
  gtk_widget_show (spinbutton_perc);
  gtk_table_attach (GTK_TABLE (table3), spinbutton_perc, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  entry_clip = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_clip", entry_clip);
  gtk_widget_show (entry_clip);
  gtk_table_attach (GTK_TABLE (table3), entry_clip, 1, 2, 2, 3,
		    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0); 
  gtk_entry_set_text (GTK_ENTRY (entry_clip), "(perc)");

  spinbutton_xcur_adj = gtk_adjustment_new (1.0, 0.5, 5.0, 0.5, 10, 10);
  spinbutton_xcur = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_xcur_adj), 1, 1);
  gtk_object_set_data (GTK_OBJECT (dialog_option), "spinbutton_xcur", spinbutton_xcur);
  gtk_widget_show (spinbutton_xcur);
  gtk_table_attach (GTK_TABLE (table3), spinbutton_xcur, 1, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  spinbutton_wigclip_adj = gtk_adjustment_new (0, 0, 5, 1, 10, 10);
  spinbutton_wigclip = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_wigclip_adj), 1, 1);
  gtk_object_set_data (GTK_OBJECT (dialog_option), "spinbutton_wigclip", spinbutton_wigclip);
  gtk_widget_show (spinbutton_wigclip);
  gtk_table_attach (GTK_TABLE (table3), spinbutton_wigclip, 1, 2, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  /* Mouse picks */
  frame_mpick = gtk_frame_new ("Mouse Picks");
  gtk_widget_show (frame_mpick);
  gtk_box_pack_start (GTK_BOX (vbox1), frame_mpick, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_mpick), 5);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox6);
  gtk_container_add (GTK_CONTAINER (frame_mpick), hbox6);
  gtk_container_border_width (GTK_CONTAINER (hbox6), 5);

  label_mpicks = gtk_label_new ("Mpicks: ");
  gtk_widget_show (label_mpicks);
  gtk_box_pack_start (GTK_BOX (hbox6), label_mpicks, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label_mpicks), GTK_JUSTIFY_LEFT);

  entry_mpicks = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_mpicks", entry_mpicks);
  gtk_widget_show (entry_mpicks);
  gtk_box_pack_start (GTK_BOX (hbox6), entry_mpicks, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_mpicks), "/dev/tty");

  /* Right Panel */
  hbox_r = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_r);
  gtk_box_pack_start (GTK_BOX (vbox_u), hbox_r, TRUE, TRUE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox_l), vbox2, TRUE, TRUE, 0);

  /* Title */
  frame_title = gtk_frame_new ("Title");
  gtk_widget_show (frame_title);
  gtk_box_pack_start (GTK_BOX (vbox2), frame_title, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_title), 5);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (frame_title), hbox5);
  gtk_container_border_width (GTK_CONTAINER (hbox5), 5);

  label_title = gtk_label_new ("Title: ");
  gtk_widget_show (label_title);
  gtk_box_pack_start (GTK_BOX (hbox5), label_title, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label_title), GTK_JUSTIFY_LEFT);

  entry_title = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_title", entry_title);
  gtk_widget_show (entry_title);
  gtk_box_pack_start (GTK_BOX (hbox5), entry_title, TRUE, TRUE, 0);

  /* Axis parameters */
  frame_axis = gtk_frame_new ("Axis Settings");
  gtk_widget_show (frame_axis);
  gtk_box_pack_start (GTK_BOX (vbox2), frame_axis, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_axis), 5);

  table2 = gtk_table_new (14, 2, FALSE);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame_axis), table2);
  gtk_container_border_width (GTK_CONTAINER (table2), 5);

  label_axis1 = gtk_label_new ("Axis1:");
  gtk_widget_show (label_axis1);
  gtk_table_attach (GTK_TABLE (table2), label_axis1, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_axis1), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_axis1), 0.2, 0.5);

  label_label1 = gtk_label_new ("Label:");
  gtk_widget_show (label_label1);
  gtk_table_attach (GTK_TABLE (table2), label_label1, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_label1), GTK_JUSTIFY_LEFT);

  label_min1 = gtk_label_new ("Begin: ");
  gtk_widget_show (label_min1);
  gtk_table_attach (GTK_TABLE (table2), label_min1, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_min1), GTK_JUSTIFY_LEFT);

  label_max1 = gtk_label_new ("End: ");
  gtk_widget_show (label_max1);
  gtk_table_attach (GTK_TABLE (table2), label_max1, 0, 1, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_max1), GTK_JUSTIFY_LEFT);

  label_d1num = gtk_label_new ("NumTic: ");
  gtk_widget_show (label_d1num);
  gtk_table_attach (GTK_TABLE (table2), label_d1num, 0, 1, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_d1num), GTK_JUSTIFY_LEFT);

  label_tic1 = gtk_label_new ("Tic: ");
  gtk_widget_show (label_tic1);
  gtk_table_attach (GTK_TABLE (table2), label_tic1, 0, 1, 5, 6,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_tic1), GTK_JUSTIFY_LEFT);

  label_grid1 = gtk_label_new ("Grid:");
  gtk_widget_show (label_grid1);
  gtk_table_attach (GTK_TABLE (table2), label_grid1, 0, 1, 6, 7,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_grid1), GTK_JUSTIFY_LEFT);

  label_axis2 = gtk_label_new ("Axis2");
  gtk_widget_show (label_axis2);
  gtk_table_attach (GTK_TABLE (table2), label_axis2, 0, 1, 7, 8,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_axis2), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_axis2), 0.2, 0.5);

  label_label2 = gtk_label_new ("Label: ");
  gtk_widget_show (label_label2);
  gtk_table_attach (GTK_TABLE (table2), label_label2, 0, 1, 8, 9,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_label2), GTK_JUSTIFY_LEFT);

  label_min2 = gtk_label_new ("Begin:");
  gtk_widget_show (label_min2);
  gtk_table_attach (GTK_TABLE (table2), label_min2, 0, 1, 9, 10,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_min2), GTK_JUSTIFY_LEFT);

  label_max2 = gtk_label_new ("End:");
  gtk_widget_show (label_max2);
  gtk_table_attach (GTK_TABLE (table2), label_max2, 0, 1, 10, 11,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_max2), GTK_JUSTIFY_LEFT);

  label_d2num = gtk_label_new ("NumTic: ");
  gtk_widget_show (label_d2num);
  gtk_table_attach (GTK_TABLE (table2), label_d2num, 0, 1, 11, 12,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_d2num), GTK_JUSTIFY_LEFT);

  label_tic2 = gtk_label_new ("Tic:");
  gtk_widget_show (label_tic2);
  gtk_table_attach (GTK_TABLE (table2), label_tic2, 0, 1, 12, 13,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_tic2), GTK_JUSTIFY_LEFT);

  label_grid2 = gtk_label_new ("Grid:");
  gtk_widget_show (label_grid2);
  gtk_table_attach (GTK_TABLE (table2), label_grid2, 0, 1, 13, 14,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_label_set_justify (GTK_LABEL (label_grid2), GTK_JUSTIFY_LEFT);

  entry_label1 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_label1", entry_label1);
  gtk_widget_show (entry_label1);
  gtk_table_attach (GTK_TABLE (table2), entry_label1, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_label1), "Time (s)");

  entry_min1 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_min1", entry_min1);
  gtk_widget_show (entry_min1);
  gtk_table_attach (GTK_TABLE (table2), entry_min1, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_min1), "(min)");

  entry_max1 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_max1", entry_max1);
  gtk_widget_show (entry_max1);
  gtk_table_attach (GTK_TABLE (table2), entry_max1, 1, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_max1), "(max)");

  entry_d1num = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_d1num", entry_d1num);
  gtk_widget_show (entry_d1num);
  gtk_table_attach (GTK_TABLE (table2), entry_d1num, 1, 2, 4, 5,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_d1num), "(auto)");

  spinbutton_tic1_adj = gtk_adjustment_new (1, 1, 10, 1, 10, 10);
  spinbutton_tic1 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_tic1_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog_option), "spinbutton_tic1", spinbutton_tic1);
  gtk_widget_show (spinbutton_tic1);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_tic1, 1, 2, 5, 6,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_tic1), TRUE);

  hbox7 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox7);
  gtk_table_attach (GTK_TABLE (table2), hbox7, 1, 2, 6, 7,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_grid1_none = gtk_radio_button_new_with_label (grid1_group, "None");
  grid1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid1_none));
  gtk_widget_show (radiobutton_grid1_none);
  gtk_box_pack_start (GTK_BOX (hbox7), radiobutton_grid1_none, FALSE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_grid1_none), TRUE);

  radiobutton_grid1_dot = gtk_radio_button_new_with_label (grid1_group, "Dot");
  grid1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid1_dot));
  gtk_widget_show (radiobutton_grid1_dot);
  gtk_box_pack_start (GTK_BOX (hbox7), radiobutton_grid1_dot, FALSE, TRUE, 0);

  radiobutton_grid1_dash = gtk_radio_button_new_with_label (grid1_group, "Dash");
  grid1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid1_dash));
  gtk_widget_show (radiobutton_grid1_dash);
  gtk_box_pack_start (GTK_BOX (hbox7), radiobutton_grid1_dash, FALSE, TRUE, 0);

  radiobutton_grid1_solid = gtk_radio_button_new_with_label (grid1_group, "Solid");
  grid1_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid1_solid));
  gtk_widget_show (radiobutton_grid1_solid);
  gtk_box_pack_start (GTK_BOX (hbox7), radiobutton_grid1_solid, FALSE, TRUE, 0);

  entry_label2 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_label2", entry_label2);
  gtk_widget_show (entry_label2);
  gtk_table_attach (GTK_TABLE (table2), entry_label2, 1, 2, 8, 9,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_label2), "Trace Number");

  entry_min2 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_min2", entry_min2);
  gtk_widget_show (entry_min2);
  gtk_table_attach (GTK_TABLE (table2), entry_min2, 1, 2, 9, 10,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_min2), "(min)");

  entry_max2 = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_max2", entry_max2);
  gtk_widget_show (entry_max2);
  gtk_table_attach (GTK_TABLE (table2), entry_max2, 1, 2, 10, 11,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_max2), "(max)");

  entry_d2num = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_d2num", entry_d2num);
  gtk_widget_show (entry_d2num);
  gtk_table_attach (GTK_TABLE (table2), entry_d2num, 1, 2, 11, 12,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_d2num), "(auto)");


  spinbutton_tic2_adj = gtk_adjustment_new (1, 1, 10, 1, 10, 10);
  spinbutton_tic2 = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_tic2_adj), 1, 0);
  gtk_object_set_data (GTK_OBJECT (dialog_option), "spinbutton_tic2", spinbutton_tic2);
  gtk_widget_show (spinbutton_tic2);
  gtk_table_attach (GTK_TABLE (table2), spinbutton_tic2, 1, 2, 12, 13,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (spinbutton_tic2), TRUE);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox8);
  gtk_table_attach (GTK_TABLE (table2), hbox8, 1, 2, 13, 14,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);

  radiobutton_grid2_none = gtk_radio_button_new_with_label (grid2_group, "None");
  grid2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid2_none));
  gtk_widget_show (radiobutton_grid2_none);
  gtk_box_pack_start (GTK_BOX (hbox8), radiobutton_grid2_none, FALSE, TRUE, 0);
  gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (radiobutton_grid2_none), TRUE);

  radiobutton_grid2_dot = gtk_radio_button_new_with_label (grid2_group, "Dot");
  grid2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid2_dot));
  gtk_widget_show (radiobutton_grid2_dot);
  gtk_box_pack_start (GTK_BOX (hbox8), radiobutton_grid2_dot, FALSE, TRUE, 0);

  radiobutton_grid2_dash = gtk_radio_button_new_with_label (grid2_group, "Dash");
  grid2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid2_dash));
  gtk_widget_show (radiobutton_grid2_dash);
  gtk_box_pack_start (GTK_BOX (hbox8), radiobutton_grid2_dash, FALSE, TRUE, 0);

  radiobutton_grid2_solid = gtk_radio_button_new_with_label (grid2_group, "Solid");
  grid2_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_grid2_solid));
  gtk_widget_show (radiobutton_grid2_solid);
  gtk_box_pack_start (GTK_BOX (hbox8), radiobutton_grid2_solid, FALSE, TRUE, 0);

  /* More options */
  vbox_l = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_l);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox_l, TRUE, TRUE, 0);

  frame_more = gtk_frame_new ("More...");
  gtk_widget_show (frame_more);
  gtk_box_pack_start (GTK_BOX (vbox_l), frame_more, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (frame_more), 5);

  vbox_m1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox_m1);
  gtk_container_add (GTK_CONTAINER (frame_more), vbox_m1);
  gtk_container_border_width (GTK_CONTAINER (vbox_m1), 5);

  hbox_m1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_m1);
  gtk_box_pack_start (GTK_BOX (vbox_m1), hbox_m1, TRUE, TRUE, 0);

  button_ximage = gtk_button_new_with_label ("More <Ximage> Options....");
  gtk_widget_show (button_ximage);
  gtk_box_pack_start (GTK_BOX (hbox_m1), button_ximage, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (button_ximage), 10);
  gtk_signal_connect (GTK_OBJECT (button_ximage), "clicked",
                      GTK_SIGNAL_FUNC (create_dialog_imageopt),
                      NULL);

  button_curve = gtk_button_new_with_label ("Curve Plot Options");
  gtk_widget_show (button_curve);
  gtk_box_pack_start (GTK_BOX (hbox_m1), button_curve, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (button_curve), 10);
  gtk_signal_connect (GTK_OBJECT (button_curve), "clicked",
                      GTK_SIGNAL_FUNC (create_dialog_curveopt),
                      NULL);

  hbox_m2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox_m2);
  gtk_box_pack_start (GTK_BOX (vbox_m1), hbox_m2, TRUE, TRUE, 0);

  label_add = gtk_label_new ("Additional Options:");
  gtk_widget_show (label_add);
  gtk_box_pack_start (GTK_BOX (hbox_m2), label_add, FALSE, TRUE, 10);
  gtk_label_set_justify (GTK_LABEL (label_add), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment (GTK_MISC (label_add), 0.2, 0.5);

  entry_add = gtk_entry_new ();
  gtk_object_set_data (GTK_OBJECT (dialog_option), "entry_add", entry_add);
  gtk_widget_show (entry_add);
  gtk_box_pack_start (GTK_BOX (hbox_m2), entry_add, TRUE, TRUE, 0);

  /* Buttons */
  dialog_action_area1 = GTK_DIALOG (dialog_option)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbuttonbox1, TRUE, TRUE, 0);

  button_ok = gtk_button_new_with_label ("OK");
  gtk_widget_show (button_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_ok);
  gtk_widget_grab_focus (button_ok);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_style),
                      (gpointer)style_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_wt),
                      (gpointer)wt_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_va),
                      (gpointer)va_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_int),
                      (gpointer)int_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_grid1),
                      (gpointer)grid1_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (check_radio_button_grid2),
                      (gpointer)grid2_group);
  gtk_signal_connect (GTK_OBJECT (button_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_option_ok_clicked),
                      dialog_option);

  button_reset = gtk_button_new_with_label ("Reset");
  gtk_widget_show (button_reset);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_reset);
  gtk_widget_set_sensitive (button_reset, FALSE);
  gtk_signal_connect (GTK_OBJECT (button_reset), "clicked",
                      GTK_SIGNAL_FUNC (on_option_reset_clicked),
                      dialog_option);

  button_cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_show (button_cancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button_cancel);
  gtk_signal_connect (GTK_OBJECT (button_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_option_cancel_clicked),
                      dialog_option);

  gtk_widget_show (dialog_option);

  gtk_grab_add(dialog_option);
  gtk_main ();
  gtk_grab_remove(dialog_option);

  return;
}

