/*  suxviewer
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

/* Function prototype declarations */
void create_dialog_option (GtkWidget *widget, gpointer data);

void check_radio_button_style (GtkWidget *widget, gpointer data);
void check_radio_button_wt (GtkWidget *widget, gpointer data);
void check_radio_button_va (GtkWidget *widget, gpointer data);
void check_radio_button_int (GtkWidget *widget, gpointer data);
void check_radio_button_grid1 (GtkWidget *widget, gpointer data);
void check_radio_button_grid2 (GtkWidget *widget, gpointer data);

void on_option_ok_clicked (GtkButton *button, GtkWidget *dialog);
void on_option_reset_clicked (GtkButton *button, GtkWidget *dialog);
void on_option_cancel_clicked (GtkButton *button, GtkWidget *dialog);

void create_dialog_imageopt (GtkWidget *widget, gpointer data);
void on_image_cancel_clicked (GtkButton *button, GtkWidget *dialog);
void on_image_ok_clicked (GtkButton *button, GtkWidget *dialog);
void get_legend_options (GtkButton *button, GtkWidget *dialog);

void on_radiobutton_ly_toggled (GtkToggleButton *togglebutton, gpointer data);
void on_radiobutton_ln_toggled (GtkToggleButton *togglebutton, gpointer data);
void check_radiobutton_legend (GtkWidget *widget, gpointer data);
void get_legend_options (GtkButton *button, GtkWidget *dialog);

void create_dialog_curveopt (GtkWidget *widget, gpointer data);
void on_curve_add_clicked (GtkButton *button, GtkWidget *dialog);
void on_curve_clear_clicked (GtkButton *button, GtkWidget *dialog);
void on_curve_ok_clicked (GtkButton *button, GtkWidget *dialog);
void on_curve_cancel_clicked (GtkButton *button, GtkWidget *dialog);

/* Structures as global variables */
struct op_param {
  gint yes;
  gchar *style;
  gchar *wt;
  gchar *va;
  gchar *interp;
  gchar *key;
  gchar *bias;
  gchar *perc;
  gchar *clip;
  gchar *xcur;
  gchar *wigclip;
  gchar *mpicks;
  gchar *title;
  gchar *label1;
  gchar *min1;
  gchar *max1;
  gchar *d1num;
  gchar *tic1;
  gchar *grid1;
  gchar *label2;
  gchar *min2;
  gchar *max2;
  gchar *d2num;
  gchar *tic2;
  gchar *grid2;
  gchar *add;
} option;

struct image_param {
  gint yes;
  gchar *bperc;
  gchar *wperc;
  gchar *bclip;
  gchar *wclip;
  gchar *blank;
  gchar *cmap;
} image;

struct legend_param {
  gint yes;
  gchar *legend;
  gchar *units;
  gchar *xbox;
  gchar *ybox;
  gchar *lwidth;
  gchar *lheight;
  gchar *lx;
  gchar *ly;
} legend;

struct curve_param {
  gint ncurve;
  gchar curve[128];
  gchar npair[128];
  gchar curvecolor[128];
} curve;

