/*  suxviewer
 *  by Watanabe Toshiki, Kyoto University
 *  Copyright (C) 1999, Watanabe Toshiki
 *
 *  SuXViewer: a simple GUI viewer of SU data 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
*/

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
#include "suxviewer.h"
#include "option.h"

void main_quit(GtkWidget *widget, GtkWidget *window)
{
  g_print ("Thank you for using SU XViewer!\n"); 
  /* gtk_main_quit (); */
  /* If we use "gtk_main_quit()" to quit program, it fails and requires */
  /* pushing it for several times with warnings.                        */ 
  /* therefore we use "gtk_exit(0).                                     */
  gtk_exit (0);
}

/* Main window */
GtkWidget* create_window ()
{
  GtkWidget *window;
  GtkWidget *vbox;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *button4;
  GtkWidget *button5;
  GtkWidget *button6;

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_signal_connect(GTK_OBJECT(window), "destroy",
		     GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_window_set_title(GTK_WINDOW(window), "SU XViewer");

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);

  button1 = gtk_button_new_with_label("File");
  gtk_box_pack_start(GTK_BOX(vbox), button1, TRUE, FALSE, 0);
  gtk_widget_show(button1);
  gtk_signal_connect(GTK_OBJECT(button1), "clicked",
		     GTK_SIGNAL_FUNC(file_selection), NULL);

  button2 = gtk_button_new_with_label("Option");
  gtk_box_pack_start(GTK_BOX(vbox), button2, TRUE, FALSE, 0);
  gtk_widget_show(button2);
  gtk_signal_connect(GTK_OBJECT(button2), "clicked",
		     GTK_SIGNAL_FUNC(create_dialog_option), NULL);

  button3 = gtk_button_new_with_label("View (wiggle)");
  gtk_box_pack_start(GTK_BOX(vbox), button3, TRUE, FALSE, 0);
  gtk_widget_show(button3);
  gtk_signal_connect(GTK_OBJECT(button3), "clicked",
		     GTK_SIGNAL_FUNC(exec_view_wiggle), NULL);

  button6 = gtk_button_new_with_label("View (image)");
  gtk_box_pack_start(GTK_BOX(vbox), button6, TRUE, FALSE, 0);
  gtk_widget_show(button6);
  gtk_signal_connect(GTK_OBJECT(button6), "clicked",
		     GTK_SIGNAL_FUNC(exec_view_image), NULL);

  button4 = gtk_button_new_with_label("About");
  gtk_box_pack_start(GTK_BOX(vbox), button4, TRUE, FALSE, 0);
  gtk_widget_show(button4);
  gtk_signal_connect(GTK_OBJECT(button4), "clicked",
		     GTK_SIGNAL_FUNC(about_window), NULL);

  button5 = gtk_button_new_with_label("Quit");
  gtk_box_pack_start(GTK_BOX(vbox), button5, TRUE, FALSE, 0);
  gtk_widget_show(button5);
  gtk_signal_connect(GTK_OBJECT(button5), "clicked",
 		     GTK_SIGNAL_FUNC(main_quit), window); 

  return window;
}

int main (int argc, char *argv[])
{
  GtkWidget *window;

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  window = create_window ();
  gtk_widget_show (window);

  gtk_main ();
  return 0;
}
